#ifndef __INCLUDED_PLAYERS_H
#define __INCLUDED_PLAYERS_H

#include "common/globgame.h"
#include "common/lists.h"

struct team_info {
	int active;
	char *name;
	int score, deaths;
	int fwon, flost, fstolen;
};
extern struct team_info teams[MAX_TEAMS];
extern int teams_count;

void    init_teams(void);


struct player_info {
	LIST_HEAD(struct player_info);

	long id;
	long team_id;
	int score;
	int deaths;
	int flagged;
	int glamor;
	char nick[1];
};
extern struct player_info players;
extern struct player_info *self_player;
extern int my_id;
extern int players_count;

extern long double_kill;
extern long multi_kill;
extern long last_kill;

void player_move_up(struct player_info *pos, struct player_info *plr);
void player_move_down(struct player_info *pos, struct player_info *plr);
struct player_info * add_player(long id, char *nick, int score, int deaths);
void del_player(struct player_info *plr);
struct player_info * find_player(long id);
char * player_nick_by_id(long id);
void dead_player(struct player_info *plr);
void kill_player(struct player_info *victim, struct player_info *killer);

void render_playerlist(void);

#endif
