#ifndef __INCLUDED_BYTEF_H
#define __INCLUDED_BYTEF_H

#include "common/types.h"

/* bscanf() takes binary data from buffer and parses them accordingly to the
 * passed format string:
 * b,w,d - byte, word, dword pointers; BEWARE - pass only pointers to vars of
 *         fixed-size types, otherwise some higher octets of the variable may
 *         be left uninitialized!
 * q   	 - string; takes two arguments: the string buffer length (<=> the max
 *         string length) u16* pointer and the string buffer pointer.
 *         The scanned string is nul-terminated. */
u16	bscanf(u8 *src, u16 len, u8 *fmt, ...);

/* Opposite of bprintf(). The format string is similar:
 * b,w,d - byte, word, dword
 * s     - string (as q, but length is just strlen())
 * q     - sized string; takes two arguments: the string length and
 *         the string pointer. The string needs not to be nul-terminated.
 *         The string length is sent automatically along the string. */
u8	*bprintf(u8 *dest, u16 maxlen, u8 *fmt, ...);

#endif
