#ifndef __INCLUDED_CONN_H
#define __INCLUDED_CONN_H

/* socket + bind + connect */
#include <sys/types.h>
#include <sys/socket.h>
/* fcntl */
#include <unistd.h>
#include <fcntl.h>
/* inet_aton */
#include <netinet/in.h>
#include <arpa/inet.h>
/* buffers */
#include "common/buffer.h"
/*#include "common/event.h"*/

struct conn {
	int fd, state;
	struct sockaddr_in sin;
	struct buffer *in, *out;
};

#define SET_NONBLOCK(b) \
	fcntl(b, F_SETFL, fcntl(b, F_GETFL, 0)|O_NONBLOCK) 
#define SET_BLOCK(b) \
	fcntl(b, F_SETFL, fcntl(b, F_GETFL, 0)&(~O_NONBLOCK))
#define CONN_PUTB(c,s,l) buffer_write(c->out, c->fd, s, l)
#define CONN_PUTS(c,s) buffer_write(c->out, c->fd, s, strlen(s))

#define	CS_ERROR	1
#define CS_CONNECTING	2
#define CS_LISTEN	3
#define CS_CONNECTED	4

in_addr_t inet_resolve (char *str);

struct conn	*conn_create (struct sockaddr_in addr);
void	conn_destroy (struct conn *c);
struct conn	*conn_connect (struct sockaddr_in addr);
struct conn	*conn_bind (struct sockaddr_in addr, int nlist);
struct conn	*conn_accept (struct conn *c);
struct conn	*conn_bind_port (int port, int nlist);
struct conn	*conn_connect_resolv (char *str, int port);
int	conn_finalize_connect (struct conn *c);
void	conn_setbuff (struct conn *c, int inbuff, int outbuff);

#endif

