#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "common/debug.h"

FILE	*debug_out = NULL;

void	hexdump (char *name, char *s, int len)
{
	int i, n, k;
	if (debug_out == NULL)
		debug_out = stderr;
	fprintf(debug_out, "Hex dump of %s:\n", name);
	if (len <= 0) {
		fprintf(debug_out, "sorry, size is: %d", len);
		return;
	}
	for (i=0; i<len; i++) {
		if (i%16 == 0) {
			fprintf(debug_out, "%08x: ", i);
			n = (i+16<len?16:len-i);
			for (k=0; k<n; k++) 
				putc(isprint(s[i+k])?s[i+k]:'.', debug_out);
			for (k=0; k<16-n; k++)
				putc(' ', debug_out);
		}
		fprintf(debug_out, " %02X", s[i]&0xFF);
		if ((i+1)%16 == 0)
			fprintf(debug_out, "\n");
	}
	if (i%16 != 0)
		fprintf(debug_out, "\n");
}

void	debuglog(char *name)
{
	debug_out = fopen(name, "w");
	if (debug_out == NULL) {
		perror("cannot open debuglog");
		exit(42);
	}
	setvbuf(debug_out, (char *)NULL, _IONBF, 0);
}
