#ifndef __INCLUDED_DEBUG_H
#define __INCLUDED_DEBUG_H


#ifdef EBUG
#include <stdio.h>
#include <time.h>

extern 	FILE *debug_out;

#define DEBUG(params...) do { if (debug_out == NULL) debug_out = stderr; fprintf(debug_out, "%s@%s:%d - ", __FUNCTION__, __FILE__, __LINE__); fprintf(debug_out, params); putc('\n', debug_out); fflush(debug_out); } while (0)


#else


#define DEBUG(params...) 

#endif


#ifdef EBUG2

#define DEBUGDUMP(name,ptr,size) hexdump(name,(char *) ptr,size)
#define DEBUGDMP(ptr,size) hexdump("@" __FILE__, ptr, size)

#else

#define DEBUGDUMP(params...)
#define DEBUGDMP(params...)

#endif


void	hexdump (char *name, char *s, int len);
void	debuglog(char *name);

#endif
