#ifndef __INCLUDED_GLOBGAME_H
#define __INCLUDED_GLOBGAME_H

/* Game stuff shared by both the server and the client. */

#define DEFAULT_PORT    37113

enum game_style {
	GSTYLE_DM, /* deathmatch */
	GSTYLE_LMS, /* last man standing */
	GSTYLE_CTF, /* capture the flag */

	GSTYLE_MAX
};

#define MAX_TEAMS       7

#define	TANK_SPEED	16
#define	TANK_PSPEED	4 /* log[2] TANK_SPEED */

#define	BULLET_SPEED	16
#define BULLET_POWER	6 /* >4 if it is to get through 1 y-char of dirt */

#define DIRT_SLOWING	2 /* speed *= slowing, where slowing = this * dirt / dirt_threshold */
#ifdef SD_GRADUAL_SLOWING
/* This simulates dirt getting to the tank mechanics, but it feels quite weird
 * and is not how it looks in the original tunneler. */
#define DIRT_RECOVERY	3 /* delay in ticks between each dirt recovery */
#define DIRT_RECOVERY_RATIO 1/3 /* how much of dirt we remove each recovery tick */
#define DIRT_THRESHOLD  7 /* dirt slowdown threshold */
#else
#define DIRT_RECOVERY	1 /* delay in ticks between each dirt recovery */
#define DIRT_RECOVERY_RATIO 1 /* how much of dirt we remove each recovery tick */
#define DIRT_THRESHOLD  3 /* dirt slowdown threshold */
#endif

#define	BULLET_BURST	2
//#define BULLET_TICKS	10
#define BULLET_TICKS	1
#define MAX_BULLETS	6

/* the higher number, the less energy movemenet takes */
#define MOVEMENT_CONSUMPTION 4
/* fire consumption, how much energy one fire takes */
#define FIRE_CONSUMPTION 40
#define IDLE_CONSUMPTION 4

#define MAX_ENERGY	6000
#define MAX_SHIELDS	50

#define ADDE_FOREIGN	400
#define ADDE_HOME	550
#define ADDS_HOME	2
/* Fortress */
#define FADDE_FOREIGN	50
#define FADDE_HOME	70
#define FADDS_HOME	1

/* Minimal distance between fortresses (divided by number of teams - 1) */
#define CTF_FORT_FORT_MINDIST  (SURFACE_WIDTH*XPOINTS_PERCHAR*3/5)
/* Minimal distance between fortresses and homes (we can't distinguish
 * friendly/hostile homes because at the time of home placement the
 * team is not set yet). */
#define CTF_FORT_HOME_MINDIST (SURFACE_WIDTH*XPOINTS_PERCHAR*1/5)
/* Maximal number of iterations when searching such a place */
#define PLACEMENT_MAXITERS 500



#define FPS	20
#define	TICKMS	(1000/FPS)

#define	MAX_NICKLEN	32
#define	MAX_MSGLEN	128


#endif
