/* $Id: lists.h,v 1.2 2005/01/26 13:35:21 pasky Exp $ */
/*
   vykradeno z elinksu
   	toho nejlepsiho weboveho browseru
		na svete
			(mozna)
*/

#ifndef EL__UTIL_LISTS_H
#define EL__UTIL_LISTS_H

struct list_head {
	void *next;
	void *prev;
};

struct xlist_head {
	struct xlist_head *next;
	struct xlist_head *prev;
};

#define NULL_LIST_HEAD NULL, NULL
#define D_LIST_HEAD(x) &x, &x
#define INIT_LIST_HEAD(x) struct list_head x = { D_LIST_HEAD(x) }
#define LIST_HEAD(x) x *next; x *prev


/*#ifdef HAVE_TYPEOF*/
#define list_typeof(x) typeof(x)
/*
#else
#define list_typeof(x) struct xlist_head *
#endif 
*/


#define init_list(x) \
do { \
	(x).next = (x).prev = &(x); \
} while (0)


#define list_empty(x) ((x).next == &(x))
#define list_has_next(l,p) \
	((p)->next !=  (void *) &(l))

#define del_from_list(x) \
do { \
	(x)->next->prev = (x)->prev; \
	(x)->prev->next = (x)->next; \
} while (0)

#define add_at_pos(p,x) \
do { \
	(x)->next = (p)->next; \
	(x)->prev = (p); \
   	(p)->next = (x); \
   	(x)->next->prev = (x); \
} while (0)


#define add_to_list(l,x) \
	add_at_pos((list_typeof(x)) &(l), (list_typeof(x)) (x))

#define add_to_list_end(l,x) \
	add_at_pos((list_typeof(x)) (l).prev, (list_typeof(x)) (x))

#define foreach(e,l) \
	for ((e) = (l).next; \
	     (list_typeof(e)) (e) != (list_typeof(e)) &(l); \
	     (e) = (e)->next)

#define foreachback(e,l) \
	for ((e) = (l).prev; \
	     (list_typeof(e)) (e) != (list_typeof(e)) &(l); \
	     (e) = (e)->prev)

#define foreachsafe(e, n, l) \
	for ((e) = (l).next, (n) = (e)->next; \
	     (list_typeof(e)) (e) != (list_typeof(e)) &(l); \
	     (e) = (n), (n) = (e)->next)

#define free_list(l) \
do { \
	struct xlist_head *head, *next; \
\
	foreachsafe (head, next, l) { \
		del_from_list(head); \
		mem_free(head); \
	} \
} while (0)


#endif /* EL__UTIL_LISTS_H */
