#ifndef __INCLUDED_SPRITE_H
#define __INCLUDED_SPRITE_H
#include "common/types.h"

struct sprite_char {
	char text;
	enum {
		SCA_NORMAL,
		SCA_STANDOUT,
		SCA_TRANSPARENT,
		SCA_TRANSLUCENT,
		SCA_DARKCOLOR,
		SCA_BRIGHTCOLOR,
	} attr:3;
	/* As in the escape sequence: black,red,green,brown,blue,magenta,cyan,white. */
	unsigned char color:3;
};

#define sprite_char_transparent(c) (c.attr == SCA_TRANSPARENT || c.attr == SCA_TRANSLUCENT)

struct sprite {
	u16	width, height;	
	u16	center_x, center_y;
	struct sprite_char sprite[1];
};

struct spriteset {
	u16    n;
	/* XXX: Only single frame per direction supported for now. */
	struct sprite  *frames[1];
};

struct gfx_object {
	u16	n;
	struct spriteset *directions[1];
};

enum GFX {
	GFX_TANK_ID = 0,
	GFX_EXPL_ID,
	GFX_FLAGTANK_ID,
	GFX_BULLET_ID,
	GFX_HOME_ID,
	GFX_FORTRESS_ID,
	GFX_FLAG_ID,

	GFX_MAX_ID
};
extern struct gfx_object *gfx_objects[GFX_MAX_ID];

struct gfx_object *load_gfx_object(char *name);
void load_default_gfx(void);

#endif
