#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "common/state.h"
#include "common/debug.h"
#include "common/xmalloc.h"

struct stq	*init_q(struct stq *q, s16 x, s16 y)
{
	struct viewpoint *s;
	s = (struct viewpoint *) ALLOC(sizeof(struct viewpoint));
	memset(s, 0, sizeof(struct viewpoint));
	s->sx = x;
	s->sy = y;
	s->next = NULL;
	q->last = q->first = s;
	return q;
}

struct viewpoint *addseq_q(struct stq *q, u16 seq)
{
	struct viewpoint *s;
	s = (struct viewpoint *) ALLOC(sizeof(struct viewpoint));
	s->seq = seq;
	s->next = NULL;
	q->last->next = s;
	q->last = s;
	//DEBUG("seq: %d",seq);
	//dump_q(q);
	return s;
}

struct stq	*rmlt_q(struct stq *q, u16 seq)
{
	struct viewpoint m, *s = &m, *p;
	m.next = q->first;
	while (s->next) {
		if (s->next->seq < seq) {
			p = s->next;
			s->next = s->next->next;
			FREE(p);
		} else 
			s = s->next;
	}
	q->first = m.next;
	return q;
}

void	rmall_q(struct stq *q)
{
	struct viewpoint *s, *p;
	s = q->first;
	while(s) {
		p = s;
		s = s->next;
		FREE(p);
	}
	q->first = q->last = NULL;
}

struct viewpoint *loc_q(struct stq *q, u16 seq)
{
	struct viewpoint *s;
	for(s=q->first; s; s=s->next) {
		if (s->seq == seq)
			return s;
	}
	return NULL;
}	

void	dump_q(struct stq *q)
{
	struct viewpoint *s;
	DEBUG(".-- dumping queue");
	for(s=q->first; s; s=s->next) {
		DEBUG("|  %d", s->seq);
	}
	DEBUG("`-- enddump");
}

#if 0
int	main()
{
	struct stq q;
	init_q(&q);
	dump_q(&q);
	addseq_q(&q, 1, 10);
	addseq_q(&q, 2, 15);
	addseq_q(&q, 3, 20);
	dump_q(&q);
	rmlt_q(&q, 4);
	dump_q(&q);


}
#endif

