#include <assert.h>
#include <stdlib.h>
#include "common/debug.h"
#include "common/globgame.h"
#include "common/math.h"
#include "common/surface.h"
#include "common/xmalloc.h"
#include "server/console.h"
#include "server/game.h"
#include "server/server.h"

ground	surface[SURFACE_WIDTH][SURFACE_HEIGHT];


u16	surface_calc_collision(struct spritepos *s, ground flags)
{
	struct sprite *p = s->sprite;
	u16 i, j, ret=0;

	if (s->sx + p->width > SURFACE_WIDTH || s->sx < 0 ||
	    s->sy + p->height > SURFACE_HEIGHT || s->sy < 0)
		return -1;

	FECHAR (i,j,p) {
		if (surface[s->sx+i][s->sy+j]&flags) {
			ret++;
		}
	}

	return ret;
}

void	surface_drc_sprite(struct spritepos *s, ground set_to, ground leave)
{
	struct sprite *p = s->sprite;
	u16 i, j;
	u8 c; 

	FECHAR(i,j,p) {
		c = surface[s->sx+i][s->sy+j];
		surface[s->sx+i][s->sy+j] = set_to | (c&leave);
	}
}

void	surface_drc_region(struct spritepos *s, ground set_to)
{
	struct sprite *p = s->sprite;
	u16 i, j;

	for (j=0; j<p->height; j++) 
		for (i=0; i<p->width; i++) 
			surface[s->sx+i][s->sy+j] = set_to;
}


void    init_rocks (void)
{
#define NUM_ROCKS  200
#define MAX_RADIUS 8
	int i;

	for (i = 0; i < NUM_ROCKS; i++) {
		int rx, ry, x, y;
		int xradius = mkrand(MAX_RADIUS), yradius = mkrand(MAX_RADIUS);

		x = mkrand(SURFACE_WIDTH); y = mkrand(SURFACE_HEIGHT);
		for (ry = -yradius; ry < yradius; ry++) {
			for (rx = -xradius; rx < xradius; rx++) {
				xradius += mkrand(3) - 1; yradius += mkrand(3) - 1;
				rx += mkrand(3) - 1; ry += mkrand(3) - 1;

				if ((abs(rx*ry) < abs(xradius*yradius))
				    && (x+rx > 0) && (x+ry > 0)
				    && (x+rx < SURFACE_WIDTH) && (y+ry < SURFACE_HEIGHT))
					surface[x+rx][y+ry] = G_STONE;
			}
		}
	}
#undef MAX_RADIUS
#undef NUM_ROCKS
}

void	init_surface (void)
{
	u16 i, j,n;
	DEBUG("surface init... %d", sizeof(surface));
	memset(surface, G_DIRT, sizeof(surface));
#if 0
	for (i=0; i<SURFACE_WIDTH; i++) {
		surface[i][0] = G_STONE;
		surface[i][SURFACE_HEIGHT-1] = G_STONE;
	} 
	for (i=0; i<SURFACE_HEIGHT; i++) {
		surface[0][i] = G_STONE;
		surface[SURFACE_WIDTH-1][i] = G_STONE;
	}
#endif
	n = 5;
	for (i=0; i<SURFACE_WIDTH; i++) {
		n += mkrand(10)-5;
		if (n < 5)
			n=5;
		if (n > 50) 
			n=50;
		for (j=0; j<n; j++) {
			surface[i][j] = G_STONE;
			surface[i][SURFACE_HEIGHT-j-1] = G_STONE;
		}
	}
	n = 5;
	for (i=0; i<SURFACE_HEIGHT; i++) {
		n += mkrand(10)-5;
		if (n < 5)
			n=5;
		if (n > 50) 
			n=50;
		for (j=0; j<n; j++) {
			surface[j][i] = G_STONE;
			surface[SURFACE_WIDTH-j-1][i] = G_STONE;
		}
	}
	init_rocks();
}
