#ifndef __INCLUDED_SURFACE_H
#define __INCLUDED_SURFACE_H

#include "common/types.h"
#include "common/object.h"
#include "common/sprite.h"

#define SURFACE_WIDTH 	750 /* 6000 points */
#define SURFACE_HEIGHT 	250 /* 4000 points */

#define	G_EMPTY		0
#define G_DIRT		1
#define G_STONE		2
#define G_HOME		4
#define	G_PLAYER	8
#define G_BULLET	16


typedef u8 ground;
ground	surface[SURFACE_WIDTH][SURFACE_HEIGHT];

u16	surface_calc_collision(struct spritepos *s, ground flags);
void	surface_drc_sprite(struct spritepos *s, ground set_to, ground leave);
void	surface_drc_region(struct spritepos *s, ground set_to);

void	init_surface (void);

#define FECHAR(i,j,s) for (j=0; j<s->height; j++) 		\
			for (i=0; i<s->width; i++) 		\
			  if (!sprite_char_transparent(s->sprite[j*s->width+i]))

#endif
