#ifndef __INCLUDED_UDP_H
#define __INCLUDED_UDP_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/* socket + bind + connect */
#include <sys/types.h>
#include <sys/socket.h>
/* fcntl */
#include <unistd.h>
#include <fcntl.h>
/* inet_aton */
#include <netinet/in.h>
#include <arpa/inet.h>
/* select */
#include <sys/time.h>
#include <sys/select.h>


struct uconn {
	int 	fd;
	enum {
		UCS_ERROR,
		UCS_SERVER,
		UCS_CLIENT
	} 	state;
	struct 	sockaddr_in sin;
};

struct uconn	*udp_dup (struct uconn *server, struct sockaddr_in sin);
int	udp_send (struct uconn *u, char *data, int len);
int	udp_recv (struct uconn *u, char *buf, int max, struct uconn *source);
void	udp_close (struct uconn *u);
struct uconn	*udp_server(int port);
struct uconn	*udp_client(char *str, int port);
struct uconn	*udp_bind(struct sockaddr_in saddr);
void	udp_destroy(struct uconn *u);
struct uconn	*udp_create (void);
int	udp_cmp(struct uconn *a, struct uconn *b);
int	udp_localport(struct uconn *a);

//#define	UDP_RANDDROP 25

#endif

