#ifndef __INCLUDED_XMALLOC_H
#define __INCLUDED_XMALLOC_H

void	*xcalloc(size_t nmemb, size_t size, char *ident);
void	*xmalloc(size_t size, char *ident);
void	xfree(void *ptr, char *ident);

//#define	MALLOC_TRACE

#ifdef MALLOC_TRACE
#define CALLOC(x,y) xcalloc(x, __FUNCTION__)
#define ALLOC(x) xmalloc(x, __FUNCTION__)
#define FREE(x) xfree(x, __FUNCTION__)
#else
#define CALLOC(x,y) calloc(x, y)
#define ALLOC(x) malloc(x)
#define FREE(x) free(x)
#endif

#endif
