#ifndef __INCLUDED_COLORS_H
#define __INCLUDED_COLORS_H

/* the most common text color scheme in the world - IBM colors */
#define COLOR_BLACK             0x00
#define COLOR_BLUE              0x01
#define COLOR_GREEN             0x02
#define COLOR_CYAN              0x03
#define COLOR_RED               0x04
#define COLOR_MAGENTA           0x05
#define COLOR_BROWN             0x06
#define COLOR_GRAY              0x07


/* macros expanding our color set */
#define BRIGHT(x)		((x)|0x8)
#define ISBRIGHT(x)		((x)&0x8)


/* ...so the bright variants: */
#define COLOR_DARKGRAY          BRIGHT(COLOR_BLACK)
#define COLOR_LIGHTBLUE         BRIGHT(COLOR_BLUE)
#define COLOR_LIGHTGREEN        BRIGHT(COLOR_GREEN)
#define COLOR_LIGHTCYAN         BRIGHT(COLOR_CYAN)
#define COLOR_LIGHTRED          BRIGHT(COLOR_RED)
#define COLOR_LIGHTMAGENTA      BRIGHT(COLOR_MAGENTA)
#define COLOR_YELLOW            BRIGHT(COLOR_BROWN)
#define COLOR_WHITE             BRIGHT(COLOR_GRAY)

#define COLBG(x)		((x)>>4)
#define COLFG(x)		((x)&0xf)
#define MAKEBG(x)		((x)<<4)

#endif
