/*
 * standard stdin keyboard, nothing fancy yet should work everywhere
 * -sd
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <termios.h>
#include "gameio/gameio.h"

static	struct	termios oldflags;
static	int tty_fd;

/********************************** PUBLIC ******************************/
static	int	init(int fd)
{
	struct	termios newflags;

	tcgetattr(fd, &oldflags);
	newflags = oldflags;
	newflags.c_lflag &= ~(ICANON | ECHO);
	newflags.c_iflag &= ~(IXON | IXOFF);
	tcsetattr(fd, TCSAFLUSH, &newflags);
	tty_fd = fd;
	return 0;
}

static	int	cleanup()
{
	tcsetattr(tty_fd, TCSAFLUSH, &oldflags);
	return 0;
}

static	int	getkey()
{
	char c;
	struct	timeval tv;
	fd_set rfds;
	FD_ZERO(&rfds);
	FD_SET(tty_fd, &rfds);
	tv.tv_sec = tv.tv_usec = 0;
	if (select(tty_fd+1, &rfds, NULL, NULL, &tv) != 1)
		return -1;
	read(tty_fd, &c, 1);
	return c;
}

/* driver descriptor */
struct	gi_kbd_driver std_kbd = {
	.name	=	"std",
	.desc	=	"standard terminal input",
	.raw	=	0,
	.init	=	init,
	.cleanup=	cleanup,
	.getkey	=	getkey
};
