#ifndef __INCLUDED_SERVER_H
#define __INCLUDED_SERVER_H

#include "common/types.h"
#include "common/globgame.h"
#include "server/ai.h"
#include "server/game.h"
#include "server/players.h"

extern u32 tick;

extern int do_ferda;
extern int bots_to_spawn;
extern int teams_enforce;
extern int teams_ai;

extern enum game_style gstyle;
extern int lms_lives;

/* Compatibility kludge, will be eventually phased out: */
extern struct gfx_object *gfx_tank, *gfx_bullet, *gfx_home, *gfx_explosion;

extern u16 newobj(void);

void	unicast(struct player *p, u8 *msg, u16 len);
void	broadcast(u8 *msg, u16 len);
void	bcast_join(struct player *p);
void	bcast_leave(struct player *p);
void	bcast_winner(struct player *p);
void	bcast_kill(struct player *recv, struct player *send);
void	bcast_telefrag(struct player *recv, struct player *send);
void	bcast_energydeath(struct player *plr);
void	bcast_glamorize(struct player *plr, int level);
void	bcast_pause(struct player *plr, int pause);
void	bcast_say(struct player *p, u8 *buf, u16 len);
void	bcast_teamup(struct player *p, int teamid);

void	bcast_flagpick(struct player *p, int teamid);
void	bcast_flagdrop(struct player *p, int teamid);
void	bcast_flagreturn(struct player *p, int teamid);
void	bcast_flagwin(struct player *p, int teamid);

#endif
